#define _CRT_SECURE_NO_WARNINGS
#define _SILENCE_CXX17_C_HEADER_DEPRECATION_WARNING
#include <bits/stdc++.h>
using namespace std;
#define CRP(t, x) const t &x
#define OPL(t, x) bool operator<(CRP(t, x)) const
#define FIL(x, v) memset(x, v, sizeof(x))
#define CLR(x) FIL(x, 0)
#define NE1(x) FIL(x, -1)
#define INF(x) FIL(x, 0x3f)
#ifndef _DEBUG
#define _DEBUG 0
#endif // !_DEBUG
#define IFD if (_DEBUG)
typedef long long ll, i64;
char ss[505][2050];
bool vis[505];
int main()
{
    int T, n;
    scanf("%d", &T);
    for (int t = 1; t <= T; t++)
    {
        CLR(vis);
        scanf("%d", &n);
        for (int i = 1; i <= n; i++)
            scanf("%s", ss[i]);
        int ans = -1;
        for (int i = 1; i <= n; i++)
            for (int j = 1; j < i; j++)
            {
                if (vis[j])
                    continue;
                if (strstr(ss[i], ss[j]) != nullptr)
                    vis[j] = true;
                else
                    ans = i;
            }
        printf("Case #%d: %d\n", t, ans);
    }
    return 0;
}